// wWARDRAGONxt@CovO

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <direct.h>

#include "d88.h"

static unsigned char dir[0x400 * 2];		// Directory (1024 x 2sector)
static unsigned char fat[0x400 * 1];		// 12bit FAT (1024 x 1sector)
static unsigned short int fat16[5*78];		// 16bit FAT (5sector/track x 78track)
static unsigned char buffer[0x400*5*78];	// 1024byte x 5sector x 78track

int main(int argc, char *argv[])
{
	if (argc != 2) {
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: wdfile image\n");
		return 1;
	}

	D88 disk;
	FILE *fp;

	// t@CJG[ɂȂ
	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();	// fBXNC[W

	for (int diskno = 0; diskno < numdisk; diskno++) {	// C[W̏

		disk.SelectDisk(diskno);			// 

		disk.SetRecordRange(0x01,0x05);		// gbN1ȍ~5ZN^(N=3)

		disk.ReadDATA(2, 1, 0, 1, 3, fat, sizeof(fat));	// FATǂݍ(track=2,sec=1)
		disk.ReadDATA(2, 1, 0, 2, 3, dir, sizeof(dir));	// fBNgŜǂݍ(track=2,sec=2`3)

		// Track 2ȍ~fBXNC[WۂƓǂݍ
		for (int trk = 2; trk < 80; trk++) {
			disk.ReadDATA(trk, trk>>1, trk&1, 0x01, 0x03, &buffer[0x400*5*(trk-2)], 0x400*5);
		}

/*
		fp = fopen("dirdat", "wb");			// for debug
		fwrite(dir, 1, sizeof(dir), fp);
		fclose(fp);
		fp = fopen("fatdat", "wb");			// for debug
		fwrite(fat, 1, sizeof(fat), fp);
		fclose(fp);
		fp = fopen("buffer", "wb");			// for debug
		fwrite(buffer, 1, sizeof(buffer), fp);
		fclose(fp);
*/

		// 12bit FAT͈ɂ̂ŁA16bit FATɕϊ

		unsigned char *p1;
		unsigned short int *p2;
		unsigned char fat1;
		unsigned char fat2;
		unsigned char fat3;

		p1 = fat;
		p2 = fat16;

		for (int i=0; i< 5*78/2; i++) {
			fat1 = *p1;
			p1++;
			fat2 = *p1;
			p1++;
			fat3 = *p1;
			p1++;
			*p2 = (short int(fat2) & 0x0f) * 0x100 + short int(fat1);
			p2++;
			*p2 = (short int(fat3) * 0x10) + (short int(fat2) >> 4);
			p2++;
		}

/*
		fp = fopen("fat16dat", "wb");		// for debug
		fwrite(fat16, 1, sizeof(fat16), fp);
		fclose(fp);
*/

		// t@C̐؂o
		for (int fn = 0; fn < sizeof(dir)/32; fn++) {
			unsigned char *ent = &dir[fn * 32];		// fBNgGg|C^`

			if (ent[0] == 0xe5) continue;	// killꂽt@C̓XLbv
			if (ent[0] == 0x00) break;		// fBNg̍Ō

			char fname[FILENAME_MAX];				// t@C

			int i;
			int fnp = 0;
			for (i = 0; i < 8; i++) {
				char c = ent[i];		// t@CPo
				if (c==' ') break;		// 
				fname[fnp++] = c;		// t@C\
			}
			if (ent[8] != ' ') {		// gqKvȂt
				fname[fnp++] = '.';
				for (i = 8; i < 11; i++) {	// 悤Ɋgqo
					char c = ent[i];
					if (c == 0x20) break;
					fname[fnp++] = c;
				}
			}
			fname[fnp++] = '\0';		// ̍Ō

			int attrb = ent[0x0b];		// 
			int time1 = ent[0x16];		// t@C쐬(8bit)
			int time2 = ent[0x17];		// t@C쐬(8bit)
			int date1 = ent[0x18];		// t@C쐬t(8bit)
			int date2 = ent[0x19];		// t@C쐬t(8bit)
			int crs1  = ent[0x1a];		// JnNX^(8bit)
			int crs2  = ent[0x1b];		// JnNX^(8bit)
			int size1 = ent[0x1c];		// t@CTCY1
			int size2 = ent[0x1d];		// t@CTCY2
			int size3 = ent[0x1e];		// t@CTCY3
			int size4 = ent[0x1f];		// t@CTCY4

			int filetime = time1 + time2 * 0x100;	// 쐬
			int filehh   = time2 >> 3;
			int filemm   = (filetime & 0x07e0) >> 5;
			int filess   = (time1 & 0x1f ) << 1;
			int filedate = date1 + date2 * 0x100;	// 쐬t
			int fileyy   = (date2 >> 1) + 1980;
			int filemn   = (filedate & 0x01e0) >> 5;
			int filedd   = date1 & 0x1f;

			short int cruster = crs1  + crs2  * 0x100;	// JnNX^
			int filesize = size1 + size2 * 0x100 + size3 * 0x10000 + size4 * 0x1000000 ;	// t@CTCY

			printf("%-12s %8d %04d/%02d/%02d %02d:%02d:%02d ",fname,filesize,fileyy,filemn,filedd,filehh,filemm,filess);	// t@C\

			if (attrb & 0x20) printf ("A ");
			if (attrb & 0x10) printf ("D ");
			if (attrb & 0x08) printf ("V ");
			if (attrb & 0x04) printf ("S ");
			if (attrb & 0x02) printf ("H ");
			if (attrb & 0x01) printf ("R" );
			printf ("   ");

			if (attrb & 0x08 || attrb & 0x10 ) {printf ("\n"); continue; }

			fp = fopen(fname, "wb");	// o̓t@CI[v
			int writesize = filesize;

			while (fat16[cruster] != 0x0fff) {
//				printf ("%-4x ",cruster);
				fwrite(&buffer[(cruster+1)*0x400], 1, 0x400, fp);	// 1NX^
				writesize -= 0x400;
				if (ferror(fp)) {
					fprintf(stderr, "t@C߂܂. \n");
					return 1;
				}
				cruster = fat16[cruster];	// FAT`FCH
			}

			printf ("\n",cruster);
//			printf ("%-4x\n",cruster);
			fwrite(&buffer[(cruster+1)*0x400], 1, writesize, fp);	// `FC̍Ō

			if (ferror(fp)) { 
				fprintf(stderr, "t@C߂܂. \n");
				return 1;
			}

			fclose(fp);		// t@CN[Y
			if (ferror(fp)) { 
				fprintf(stderr, "t@C߂܂. \n");
				return 1;

			}
		}
	}
	return 0;
}
